Skip to main content
`Ctrl`+`K`

# `skopt`.BayesSearchCV

class skopt.BayesSearchCV(estimator, search_spaces, optimizer_kwargs=None, n_iter=50, scoring=None, fit_params=None, n_jobs=1, n_points=1, iid='deprecated', refit=True, cv=None, verbose=0, pre_dispatch='2*n_jobs', random_state=None, error_score='raise', return_train_score=False)

  Bayesian optimization over hyper parameters.

  BayesSearchCV implements a “fit” and a “score” method. It also implements “predict”, “predict_proba”, “decision_function”, “transform” and “inverse_transform” if they are implemented in the estimator used.

  The parameters of the estimator used to apply these methods are optimized by cross-validated search over parameter settings.

  In contrast to GridSearchCV, not all parameter values are tried out, but rather a fixed number of parameter settings is sampled from the specified distributions. The number of parameter settings that are tried is given by n_iter.

  Parameters are presented as a list of skopt.space.Dimension objects.

  Parameters:
    estimator estimator object.

      A object of that type is instantiated for each search point. This object is assumed to implement the scikit-learn estimator api. Either estimator needs to provide a `score` function, or `scoring` must be passed.

    search_spaces dict, list of dict or list of tuple containing (dict, int).

      One of these cases: 1. dictionary, where keys are parameter names (strings) and values are skopt.space.Dimension instances (Real, Integer or Categorical) or any other valid value that defines skopt dimension (see skopt.Optimizer docs). Represents search space over parameters of the provided estimator. 2. list of dictionaries: a list of dictionaries, where every dictionary fits the description given in case 1 above. If a list of dictionary objects is given, then the search is performed sequentially for every parameter space with maximum number of evaluations set to self.n_iter. 3. list of (dict, int > 0): an extension of case 2 above, where first element of every tuple is a dictionary representing some search subspace, similarly as in case 2, and second element is a number of iterations that will be spent optimizing over this subspace.

    n_iter int, default=50

      Number of parameter settings that are sampled. n_iter trades off runtime vs quality of the solution. Consider increasing `n_points` if you want to try more parameter settings in parallel.

    optimizer_kwargs dict, optional

      Dict of arguments passed to `Optimizer`. For example, `{'base_estimator': 'RF'}` would use a Random Forest surrogate instead of the default Gaussian Process.

    scoring str, callable, list, tuple or dict, default=None

      Strategy to evaluate the performance of the cross-validated model on the test set. If `None`, the `score` method of the estimator is used. If `scoring` represents a single score, one can use:

      - a single string (see scoring_parameter);

      - a callable (see scoring) that returns a single value.

      If `scoring` represents multiple scores, one can use:

      - a list or tuple of unique strings;

      - a callable returning a dictionary where the keys are the metric names and the values are the metric scores;

      - a dictionary with metric names as keys and callables a values.

      Callables must have the signature `scorer(estimator, X, y=None)`

    fit_params dict, optional

      Parameters to pass to the fit method.

    n_jobs int, default=1

      Number of jobs to run in parallel. At maximum there are `n_points` times `cv` jobs available during each iteration.

    n_points int, default=1

      Number of parameter settings to sample in parallel. If this does not align with `n_iter`, the last iteration will sample less points. See also `ask()`

    pre_dispatch int, or string, optional

      Controls the number of jobs that get dispatched during parallel execution. Reducing this number can be useful to avoid an explosion of memory consumption when more jobs get dispatched than CPUs can process. This parameter can be:

      > - None, in which case all the jobs are immediately created and spawned. Use this for lightweight and fast-running jobs, to avoid delays due to on-demand spawning of the jobs

      > - An int, giving the exact number of total jobs that are spawned

      > - A string, giving an expression as a function of n_jobs, as in ‘2*n_jobs’

    cv int, cross-validation generator or an iterable, optional

      Determines the cross-validation splitting strategy. Possible inputs for cv are:

      > - None, to use the default 3-fold cross validation,

      > - integer, to specify the number of folds in a `(Stratified)KFold`,

      > - An object to be used as a cross-validation generator.

      > - An iterable yielding train, test splits.

      For integer/None inputs, if the estimator is a classifier and `y` is either binary or multiclass, `StratifiedKFold` is used. In all other cases, `KFold` is used.

    refit bool, str, default=True

      Refit the best estimator with the entire dataset. If “False”, it is impossible to make predictions using this BayesSearchCV instance after fitting. For multiple metric evaluation, this needs to be a `str` denoting the scorer that would be used to direct the optimization process, and find the best parameters for refitting the estimator at the end.

    verbose integer

      Controls the verbosity: the higher, the more messages.

    random_state int or RandomState

      Pseudo random number generator state used for random uniform sampling from lists of possible values instead of scipy.stats distributions.

    error_score‘raise’ (default) or numeric

      Value to assign to the score if an error occurs in estimator fitting. If set to ‘raise’, the error is raised. If a numeric value is given, FitFailedWarning is raised. This parameter does not affect the refit step, which will always raise the error.

    return_train_score boolean, default=False

      If `'True'`, the `cv_results_` attribute will include training scores.

  Attributes:
    cv_results_dict of numpy (masked) ndarrays

      A dict with keys as column headers and values as columns, that can be imported into a pandas `DataFrame`.

      For instance the below given table

      param_kernel | param_gamma | split0_test_score | … | rank_test_score
      --- | --- | --- | --- | ---
      ‘rbf’ | 0.1 | 0.8 | … | 2
      ‘rbf’ | 0.2 | 0.9 | … | 1
      ‘rbf’ | 0.3 | 0.7 | … | 1

      will be represented by a `cv_results_` dict of:

          {
          'param_kernel' : masked_array(data = ['rbf', 'rbf', 'rbf'],
                                        mask = False),
          'param_gamma'  : masked_array(data = [0.1 0.2 0.3], mask = False),
          'split0_test_score'  : [0.8, 0.9, 0.7],
          'split1_test_score'  : [0.82, 0.5, 0.7],
          'mean_test_score'    : [0.81, 0.7, 0.7],
          'std_test_score'     : [0.02, 0.2, 0.],
          'rank_test_score'    : [3, 1, 1],
          'split0_train_score' : [0.8, 0.9, 0.7],
          'split1_train_score' : [0.82, 0.5, 0.7],
          'mean_train_score'   : [0.81, 0.7, 0.7],
          'std_train_score'    : [0.03, 0.03, 0.04],
          'mean_fit_time'      : [0.73, 0.63, 0.43, 0.49],
          'std_fit_time'       : [0.01, 0.02, 0.01, 0.01],
          'mean_score_time'    : [0.007, 0.06, 0.04, 0.04],
          'std_score_time'     : [0.001, 0.002, 0.003, 0.005],
          'params' : [{'kernel' : 'rbf', 'gamma' : 0.1}, ...],
          }

      NOTE that the key `'params'` is used to store a list of parameter settings dict for all the parameter candidates.

      The `mean_fit_time`, `std_fit_time`, `mean_score_time` and `std_score_time` are all in seconds.

    best_estimator_estimator

      Estimator that was chosen by the search, i.e. estimator which gave highest score (or smallest loss if specified) on the left out data. Not available if refit=False.

    optimizer_results_list of `OptimizeResult`

      Contains a `OptimizeResult` for each search space. The search space parameter are sorted by its name.

    best_score_float

      Score of best_estimator on the left out data.

    best_params_dict

      Parameter setting that gave the best results on the hold out data.

    best_index_int

      The index (of the `cv_results_` arrays) which corresponds to the best candidate parameter setting.

      The dict at `search.cv_results_['params'][search.best_index_]` gives the parameter setting for the best model, that gives the highest mean score (`search.best_score_`).

    scorer_function

      Scorer function used on the held out data to choose the best parameters for the model.

    n_splits_int

      The number of cross-validation splits (folds/iterations).

    refit_time_float

      Seconds used for refitting the best model on the whole dataset. This is present only if `refit` is not False.

    multimetric_bool

      Whether or not the scorers compute several metrics.

  See also

  `GridSearchCV`

    Does exhaustive search over a grid of parameters.

  Notes

  The parameters selected are those that maximize the score of the held-out data, according to the scoring parameter.

  If `n_jobs` was set to a value higher than one, the data is copied for each parameter setting (and not `n_jobs` times). This is done for efficiency reasons if individual jobs take very little time, but may raise errors if the dataset is large and not enough memory is available. A workaround in this case is to set `pre_dispatch`. Then, the memory is copied only `pre_dispatch` many times. A reasonable value for `pre_dispatch` is `2 * n_jobs`.

  Examples

      >>> from skopt import BayesSearchCV
      >>> # parameter ranges are specified by one of below
      >>> from skopt.space import Real, Categorical, Integer
      >>>
      >>> from sklearn.datasets import load_iris
      >>> from sklearn.svm import SVC
      >>> from sklearn.model_selection import train_test_split
      >>>
      >>> X, y = load_iris(return_X_y=True)
      >>> X_train, X_test, y_train, y_test = train_test_split(X, y,
      ...                                                     train_size=0.75,
      ...                                                     random_state=0)
      >>>
      >>> # log-uniform: understand as search over p = exp(x) by varying x
      >>> opt = BayesSearchCV(
      ...     SVC(),
      ...     {
      ...         'C': Real(1e-6, 1e+6, prior='log-uniform'),
      ...         'gamma': Real(1e-6, 1e+1, prior='log-uniform'),
      ...         'degree': Integer(1,8),
      ...         'kernel': Categorical(['linear', 'poly', 'rbf']),
      ...     },
      ...     n_iter=10, n_jobs=-1,
      ...     random_state=0
      ... )
      >>>
      >>> # executes bayesian optimization
      >>> _ = opt.fit(X_train, y_train)
      >>>
      >>> # model can be saved, used for predictions or scoring
      >>> print(opt.score(X_test, y_test))
      0.973...

  Methods

  `decision_function`(X) | Call decision_function on the estimator with the best found parameters.
  `fit`(X[, y, groups, callback]) | Run fit on the estimator with randomly drawn parameters.
  `get_metadata_routing`() | Get metadata routing of this object.
  `get_params`([deep]) | Get parameters for this estimator.
  `inverse_transform`(X) | Call inverse_transform on the estimator with the best found params.
  `predict`(X) | Call predict on the estimator with the best found parameters.
  `predict_log_proba`(X) | Call predict_log_proba on the estimator with the best found parameters.
  `predict_proba`(X) | Call predict_proba on the estimator with the best found parameters.
  `score`(X[, y]) | Return the score on the given data, if the estimator has been refit.
  `score_samples`(X) | Call score_samples on the estimator with the best found parameters.
  `set_fit_request`(*[, callback, groups]) | Configure whether metadata should be requested to be passed to the `fit` method.
  `set_params`(**params) | Set the parameters of this estimator.
  `transform`(X) | Call transform on the estimator with the best found parameters.

  __init__(estimator, search_spaces, optimizer_kwargs=None, n_iter=50, scoring=None, fit_params=None, n_jobs=1, n_points=1, iid='deprecated', refit=True, cv=None, verbose=0, pre_dispatch='2*n_jobs', random_state=None, error_score='raise', return_train_score=False)
  property classes_

    Class labels.

    Only available when `refit=True` and the estimator is a classifier.

  decision_function(X)

    Call decision_function on the estimator with the best found parameters.

    Only available if `refit=True` and the underlying estimator supports `decision_function`.

    Parameters:
      X indexable, length n_samples

        Must fulfill the input assumptions of the underlying estimator.

    Returns:
      y_score ndarray of shape (n_samples,) or (n_samples, n_classes) or (n_samples, n_classes * (n_classes-1) / 2)

        Result of the decision function for `X` based on the estimator with the best found parameters.

  fit(X, y=None, *, groups=None, callback=None, **fit_params)

    Run fit on the estimator with randomly drawn parameters.

    Parameters:
      X array-like or sparse matrix, shape = [n_samples, n_features]

        The training input samples.

      y array-like, shape = [n_samples] or [n_samples, n_output]

        Target relative to X for classification or regression (class labels should be integers or strings).

      groups array-like, with shape (n_samples,), optional

        Group labels for the samples used while splitting the dataset into train/test set.

      callback: [callable, list of callables, optional]

        If callable then `callback(res)` is called after each parameter combination tested. If list of callables, then each callable in the list is called.

  get_metadata_routing()

    Get metadata routing of this object.

    Please check User Guide on how the routing mechanism works.

    Added in version 1.4.

    Returns:
      routing MetadataRouter

        A `MetadataRouter` encapsulating routing information.

  get_params(deep=True)

    Get parameters for this estimator.

    Parameters:
      deep bool, default=True

        If True, will return the parameters for this estimator and contained subobjects that are estimators.

    Returns:
      params dict

        Parameter names mapped to their values.

  inverse_transform(X)

    Call inverse_transform on the estimator with the best found params.

    Only available if the underlying estimator implements `inverse_transform` and `refit=True`.

    Parameters:
      X indexable, length n_samples

        Must fulfill the input assumptions of the underlying estimator.

    Returns:
      X_original{ndarray, sparse matrix} of shape (n_samples, n_features)

        Result of the `inverse_transform` function for `X` based on the estimator with the best found parameters.

  property n_features_in_

    Number of features seen during fit.

    Only available when `refit=True`.

  predict(X)

    Call predict on the estimator with the best found parameters.

    Only available if `refit=True` and the underlying estimator supports `predict`.

    Parameters:
      X indexable, length n_samples

        Must fulfill the input assumptions of the underlying estimator.

    Returns:
      y_pred ndarray of shape (n_samples,)

        The predicted labels or values for `X` based on the estimator with the best found parameters.

  predict_log_proba(X)

    Call predict_log_proba on the estimator with the best found parameters.

    Only available if `refit=True` and the underlying estimator supports `predict_log_proba`.

    Parameters:
      X indexable, length n_samples

        Must fulfill the input assumptions of the underlying estimator.

    Returns:
      y_pred ndarray of shape (n_samples,) or (n_samples, n_classes)

        Predicted class log-probabilities for `X` based on the estimator with the best found parameters. The order of the classes corresponds to that in the fitted attribute classes_.

  predict_proba(X)

    Call predict_proba on the estimator with the best found parameters.

    Only available if `refit=True` and the underlying estimator supports `predict_proba`.

    Parameters:
      X indexable, length n_samples

        Must fulfill the input assumptions of the underlying estimator.

    Returns:
      y_pred ndarray of shape (n_samples,) or (n_samples, n_classes)

        Predicted class probabilities for `X` based on the estimator with the best found parameters. The order of the classes corresponds to that in the fitted attribute classes_.

  score(X, y=None, **params)

    Return the score on the given data, if the estimator has been refit.

    This uses the score defined by `scoring` where provided, and the `best_estimator_.score` method otherwise.

    Parameters:
      X array-like of shape (n_samples, n_features)

        Input data, where `n_samples` is the number of samples and `n_features` is the number of features.

      y array-like of shape (n_samples, n_output) or (n_samples,), default=None

        Target relative to X for classification or regression; None for unsupervised learning.

      **params dict

        Parameters to be passed to the underlying scorer(s).

        Added in version 1.4: Only available if `enable_metadata_routing=True`. See Metadata Routing User Guide for more details.

    Returns:
      score float

        The score defined by `scoring` if provided, and the `best_estimator_.score` method otherwise.

  score_samples(X)

    Call score_samples on the estimator with the best found parameters.

    Only available if `refit=True` and the underlying estimator supports `score_samples`.

    Added in version 0.24.

    Parameters:
      X iterable

        Data to predict on. Must fulfill input requirements of the underlying estimator.

    Returns:
      y_score ndarray of shape (n_samples,)

        The `best_estimator_.score_samples` method.

  set_fit_request(*, callback: bool | None | str = '$UNCHANGED$', groups: bool | None | str = '$UNCHANGED$') → BayesSearchCV

    Configure whether metadata should be requested to be passed to the `fit` method.

    Note that this method is only relevant when this estimator is used as a sub-estimator within a meta-estimator and metadata routing is enabled with `enable_metadata_routing=True` (see `sklearn.set_config()`). Please check the User Guide on how the routing mechanism works.

    The options for each parameter are:

    - `True`: metadata is requested, and passed to `fit` if provided. The request is ignored if metadata is not provided.

    - `False`: metadata is not requested and the meta-estimator will not pass it to `fit`.

    - `None`: metadata is not requested, and the meta-estimator will raise an error if the user provides it.

    - `str`: metadata should be passed to the meta-estimator with this given alias instead of the original name.

    The default (`sklearn.utils.metadata_routing.UNCHANGED`) retains the existing request. This allows you to change the request for some parameters and not others.

    Added in version 1.3.

    Parameters:
      callback str, True, False, or None, default=sklearn.utils.metadata_routing.UNCHANGED

        Metadata routing for `callback` parameter in `fit`.

      groups str, True, False, or None, default=sklearn.utils.metadata_routing.UNCHANGED

        Metadata routing for `groups` parameter in `fit`.

    Returns:
      self object

        The updated object.

  set_params(**params)

    Set the parameters of this estimator.

    The method works on simple estimators as well as on nested objects (such as `Pipeline`). The latter have parameters of the form `<component>__<parameter>` so that it’s possible to update each component of a nested object.

    Parameters:
      **params dict

        Estimator parameters.

    Returns:
      self estimator instance

        Estimator instance.

  property total_iterations

    Count total iterations that will be taken to explore all subspaces with `fit` method.

    Returns:
      max_iter: int, total number of iterations to explore
  transform(X)

    Call transform on the estimator with the best found parameters.

    Only available if the underlying estimator supports `transform` and `refit=True`.

    Parameters:
      X indexable, length n_samples

        Must fulfill the input assumptions of the underlying estimator.

    Returns:
      Xt{ndarray, sparse matrix} of shape (n_samples, n_features)

        `X` transformed in the new space based on the estimator with the best found parameters.